#pragma once

#include <string>
#include <cstdint>

/// A 32-bit FNV-1a hash algorithm.
/// @param [in] str The string to hash.
/// @returns The resulting hash. Zero if string does not contain any characters.
uint32_t Hash_32(const std::string& str);

/// A 64-bit FNV-1a hash algorithm.
/// @param [in] str The string to hash.
/// @returns The resulting hash. Zero if string does not contain any characters.
uint64_t Hash_64(const std::string& str);

size_t Hash(const std::string& str);