#pragma once

#include "Obj.h"
#include "Ent.h"

#include <vector>

class Level : public Obj
{
private:
	std::vector<Ent> ents;

public:
	Level();

	Level(std::string id);

	Level(Level&& lvl) noexcept;

	Level(const Level& lvl);

	Level& operator=(Level&& lvl) noexcept;

	Level& operator=(const Level& lvl);

	bool HasEnt(size_t hashId) const;

	bool HasEnt(const std::string& id) const;

	bool AddEnt(Ent newEnt);

	Ent* GetEnt(size_t hashId);

	Ent* GetEnt(const std::string& id);

	virtual void Update();

	virtual void Render();
};