#include "Hash.h"

uint32_t Hash_32(const std::string& str)
{
	if (str.empty())
		return 0;

	uint32_t hash = 2166136261ul;

	for (char c : str)
		hash = (hash ^ c) * 16777619;

	return hash;
}

uint64_t Hash_64(const std::string& str)
{
	if (str.empty())
		return 0;

	uint64_t hash = 14695981039346656037ull;

	for (char c : str)
		hash = (hash ^ c) * 1099511628211;

	return hash;
}

size_t Hash(const std::string& str)
{
	if (sizeof(void*) == 8)
		return Hash_64(str);

	return Hash_32(str);
}