#include "../include/Obj.h"

Obj::Obj()
	: hashId(0)
{
}

Obj::Obj(std::string id)
	: hashId(Hash(id)), id(std::move(id))
{
}

Obj::Obj(Obj&& obj) noexcept
	: hashId(obj.hashId), id(std::move(obj.id))
{
	obj.hashId = 0;
}

Obj::Obj(const Obj& obj)
	: hashId(obj.hashId), id(obj.id)
{
}

Obj& Obj::operator=(Obj&& obj) noexcept
{
	if (this == &obj)
		return *this;

	hashId = obj.hashId;
	id = std::move(obj.id);

	obj.hashId = 0;

	return *this;
}

Obj& Obj::operator=(const Obj& obj)
{
	if (this == &obj)
		return *this;

	hashId = obj.hashId;
	id = obj.id;

	return *this;
}

size_t Obj::GetHashId() const
{
	return hashId;
}

void Obj::SetId(std::string newId)
{
	hashId = Hash(newId);
	id = std::move(newId);
}

std::string Obj::GetId() const
{
	return id;
}